<h1 align="center">OGL-TypeScript</h1>

<p align="center">
    <a href="https://npmjs.org/package/ogl-typescript">
        <img src="https://img.shields.io/npm/v/ogl-typescript.svg" alt="version" />
    </a>
    <a href="https://github.com/nshen/ogl-typescript/blob/master/LICENSE">
        <img src="https://img.shields.io/npm/l/ogl-typescript.svg" alt="license" />
    </a>
    <a href="https://david-dm.org/nshen/ogl-typescript">
        <img src="https://img.shields.io/david/nshen/ogl-typescript.svg" alt="dependencies" />
    </a>
    <a href="https://bundlephobia.com/result?p=ogl-typescript">
        <img src="https://badgen.net/bundlephobia/minzip/ogl-typescript" alt="size" />
    </a>
</p>

<p align="center"><b>Minimal WebGL library.</b></p>

<br />

[See the Examples!](https://nshen.github.io/ogl-typescript/examples)

OGL-TypeScript is TypeScript port of [OGL Minimal WebGL library](https://github.com/oframe/ogl) , so it add code completion feature to OGL.

<img src="./code-complete.gif"  width="577px" height="337px" />

## Install

```bash
npm i ogl-typescript  # yarn add ogl-typescript
```

## Usage

Same as OGL, just change

```typescript
import { ... } from 'ogl';
```

to

```typescript
import { ... } from 'ogl-typescript'
```

You can find [ogl-typescript-starter](https://github.com/nshen/ogl-typescript-starter) here, it's very easy to get start.

## Examples

[Show me what you got!](https://nshen.github.io/ogl-typescript/examples) - Explore a comprehensive list of examples, with comments in the source code.

## Build

dev mode

```bash
yarn dev # npm run dev
```

build library

```bash
yarn build # npm run build
```

build examples

```bash
yarn build:examples # npm run build:examples
```

## Versions

| OGL-TypeScript | OGL    |                                               |
| -------------- | ------ | --------------------------------------------- |
| 0.1.40         | 0.0.71 |                                               |
| 0.1.39         | 0.0.70 |                                               |
| 0.1.38         | 0.0.69 |                                               |
| 0.1.37         | 0.0.68 |                                               |
| 0.1.36         | 0.0.67 |                                               |
| 0.1.35         | 0.0.65 |                                               |
| 0.1.34         | 0.0.64 |                                               |
| 0.1.33         | 0.0.63 |                                               |
| 0.1.32         | 0.0.62 |                                               |
| 0.1.31         | 0.0.61 | build with [vite](https://http://vitejs.dev/) |
| 0.1.20         | 0.0.60 |                                               |
| 0.1.19         | 0.0.59 |                                               |
| 0.1.18         | 0.0.58 |                                               |
| 0.1.17         | 0.0.57 |                                               |
| 0.1.16         |        | add computeVertexNormal method to Geometry    |
| 0.1.15         | 0.0.56 |                                               |
| 0.1.14         | 0.0.55 |                                               |
| 0.1.13         | 0.0.54 |                                               |
| 0.1.12         | 0.0.53 |                                               |
| 0.1.11         | 0.0.52 |                                               |
| 0.1.10         | 0.0.51 |                                               |
| 0.1.9          | 0.0.50 |                                               |
| 0.1.8          | 0.0.49 |                                               |
| 0.1.7          | 0.0.48 |                                               |
| 0.1.6          | 0.0.47 |                                               |
| 0.1.5          | 0.0.46 |                                               |
| 0.1.4          | 0.0.45 |                                               |
| 0.1.3          | 0.0.43 |                                               |
| 0.1.2          | 0.0.42 |                                               |
| 0.1.1          | 0.0.40 |                                               |
